local map = {}

map.tiles = {
  {'#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'},
  {'#',' ','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'},
  {'#',' ',' ','#','#','#','#','#','#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#','#','#','#','#','#'},
  {'#','#',' ',' ','#','#','#','#','#',' ','#','#','#',' ',' ',' ','#','#',' ','#','#','#','#','#','#'},
  {'#','#','#',' ',' ','#','#','#','#',' ','#','#','#',' ',' ',' ',' ','#',' ','#','#','#','#','#','#'},
  {'#','#','#','#',' ',' ','#','#','#','G',' ',' ',' ',' ',' ',' ','#','#',' ','#','#','#','#','#','#'},
  {'#','#',' ',' ',' ',' ','#','#','#','#','#','#','#','#',' ',' ','#','#',' ','#','#','#','#','#','#'},
  {'#','#','#',' ',' ',' ',' ','#','#','#','#','#','#','#',' ',' ','#','#',' ','#','#','#','#','#','#'},
  {'#','#',' ',' ','#',' ',' ',' ','#','#','#','#','#','#','#','#','#','#',' ','#','#','#','#','#','#'},
  {'#',' ',' ','#','#','#',' ',' ',' ','#',' ',' ',' ','#',' ',' ',' ','#',' ',' ','#','#','#','#','#'},
  {'#',' ','#','#','#','#',' ',' ',' ','a',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#','#','#','#','#'},
  {'#',' ',' ','#','#','#',' ',' ',' ','b',' ','#',' ',' ',' ','#',' ',' ',' ',' ','#','#','#','#','#'},
  {'#',' ',' ',' ',' ',' ',' ','#','#','#','#','#','#','#','#','#','#','#',' ','#','#','#','#','#','#'},
  {'#',' ',' ',' ',' ',' ',' ',' ','#',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ','#','#','#','#','#','#'},
  {'#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'},
  {'#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'},
  {'#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'},
  {'#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'},
  {'#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#','#'},

}

local player = {
  x = 2,
  y = 2
}
local playerStart = {
  x = 2,
  y = 2
}

local stepSound = love.audio.newSource("Untitled.wav", "static")

levelid = 1
local tileSize = 32

function player:update(dt)

end

function love.load()
  panelWidth = 200;
  drawTile = {' ', '#', 'a', 'b', 'E', 'L', 'P', 'I','-'}
  selectTile = 1
  moves = 0
  goalX, goalY = 10, 6
  editEnable = false
  trailsEnabled = true
  shaderEnabled = false

  fontDefault = love.graphics.getFont( )
  fontBig = love.graphics.newFont("fonts/Roboto-Light.ttf", 36)
  fontRegular = love.graphics.newFont("fonts/Roboto-Light.ttf", 14)
  fontSmall = love.graphics.newFont("fonts/Roboto-Thin.ttf", 10)

  love.filesystem.createDirectory("levels")

  love.window.setMode(25*tileSize + 204, 19*tileSize, {resizable=true, vsync=true, minwidth=400, minheight=300})
  timer = 0
  offset = 0

  currentLevel = 0

  canMove = true
  --bgMusic:play()
  canvas = love.graphics.newCanvas(love.graphics.getWidth()-panelWidth,love.graphics.getHeight())
  shader = love.graphics.newShader("screen.glsl")
  loadLevel(1)
end
somestring = ""

function raycast(dx,dy)

  local x,y = player.x, player.y

  if (map.tiles[y][x] ~= 'I' and dy == 0) or (map.tiles[y][x] ~= '-' and dx == 0) then
    repeat
      if (map.tiles[y][x] == 'P') then map.tiles[y][x] = 'p' end
      x = x + dx
      y = y + dy
    until (map.tiles[y] == nil) or (not isPassable(map.tiles[y][x])) or (map.tiles[y][x] == nil)
      or (map.tiles[y][x] == 'I' and dy == 0) or (map.tiles[y][x] == '-' and dx == 0)


    x = x - dx
    y = y - dy
  end

  return x, y;
end

local function outCirc(t, b, c, d)
  t = t / d - 1
  return(c * math.sqrt(1 - math.pow(t, 2)) + b)
end

beams = {}
function createBeam(sx, sy, dx, dy)
  local beam = {}
  beam.lifetime = 0
  beam.move = moves
  function beam:update(dt)
    if not editEnable then
      self.lifetime = self.lifetime + dt
    end
  end

  function beam:draw()
    if self.lifetime < 0.6 then
      if editEnable then
        love.graphics.setLineWidth(4)

        if (self.move % 2) == 0 then
          love.graphics.setColor(255,0,0,140)
        else
          love.graphics.setColor(255,255,255,140)
        end
      else
        love.graphics.setLineWidth((tileSize - outCirc(self.lifetime, 0, tileSize, 0.6)))
      end
      if trailsEnabled or not editEnable then
        love.graphics.line(
          tileSize*(sx-1) + tileSize/2,
          tileSize*(sy-1) + tileSize/2,
          tileSize*(dx-1) + tileSize/2,
          tileSize*(dy-1) + tileSize/2
        )
      end
      if editEnable  and trailsEnabled then
        love.graphics.setColor(0,0,0)
        love.graphics.setBlendMode("alpha")
        love.graphics.print(self.move,tileSize*(sx-1), tileSize*(sy-1)+tileSize/4)

        love.graphics.print(self.move,tileSize*(sx-1), tileSize*(sy-1)+tileSize/4+1)
        love.graphics.print(self.move,tileSize*(sx-1), tileSize*(sy-1)+tileSize/4-1)
        love.graphics.print(self.move,tileSize*(sx-1)+1, tileSize*(sy-1)+tileSize/4)
        love.graphics.print(self.move,tileSize*(sx-1)-1, tileSize*(sy-1)+tileSize/4)

        if (self.move % 2) == 0 then
          love.graphics.setColor(255,140,140)
        else
          love.graphics.setColor(255,255,255)
        end
        --love.graphics.rectangle("fill",tileSize*(sx-1), tileSize*(sy-1)+tileSize/4,tileSize,18)
        --love.graphics.setColor(0,0,0)
        love.graphics.print(self.move,tileSize*(sx-1), tileSize*(sy-1)+tileSize/4)
      end
    end
  end
  if (#beams > 3 and not editEnable) or (#beams > 100 and editEnable) then
    table.remove(beams,1)
  end
  table.insert(beams,beam)
end

stepSounds = {}

function screenToMap(x,y)
  return math.floor(x/tileSize) + 1, math.floor(y/tileSize) + 1
end

touchId = 0;
touchLastX = 0;
touchLastY = 0;
swipeTreshold = 0.08;
skewTreshold = 30;


function love.touchpressed(id, x, y, pressure)
  touchId = id
  touchLastX = x
  touchLastY = y
end

function love.touchreleased(id, x, y, pressure)

  local dx,dy = 0,0
  if touchId == id then
    if ((math.abs(x-touchLastX) > swipeTreshold*9/16))
     or ((math.abs(y-touchLastY) > swipeTreshold)) then
      if math.abs(x-touchLastX) < math.abs(y-touchLastY) then
        if (x-touchLastX) < 0 then dy = -1
        else dy = 1 end
      else
        if (y-touchLastY) < 0 then dx = 1
        else dx = -1 end
      end
    end
    touchLastX = x
    touchLastY = y

    local x,y = player.x, player.y
    if (dx ~= 0) or (dy ~= 0) then
      x,y = raycast(dx,dy)
    end

    if (player.x ~= x) or (player.y ~= y) then
      moves = moves + 1

      if (map.tiles[player.y-dy] ~= nil) and (map.tiles[player.y-dy][player.y-dx] ~= nil) then
        if map.tiles[player.y-dy][player.x-dx] == 'L' then
            map.tiles[player.y-dy][player.x-dx] = 'l'
        end
      end
      if (map.tiles[y+dy] ~= nil) and (map.tiles[y+dy][x+dx] ~= nil) then
        if map.tiles[y+dy][x+dx] == 'E' then
          map.tiles[y+dy][x+dx]  = 'e'
        end
      end

      createBeam(player.x, player.y, x, y)
      stepSounds[#stepSounds+1] = love.audio.newSource("Untitled.wav", "static")
      stepSounds[#stepSounds]:play()
      if #stepSounds > 10 then
        table.remove(stepSounds)
      end
    end
    player.x, player.y = x, y

    if (player.x == goalX) and (player.y == goalY) then
      loadLevel(currentLevel + 1)
    end

  end
end



function love.keypressed(key, isrepeat)
  somestring = "["..key.."] "..somestring
  local x,y = player.x, player.y
  local dx,dy = 0,0
  if key == "up" then
    dx,dy = 0,-1
  elseif key == "down" then
    dx,dy = 0,1
  elseif key == "left" then
    dx,dy = -1,0
  elseif key == "right" then
    dx,dy = 1,0
  end

  if (dx ~= 0) or (dy ~= 0) then
    x,y = raycast(dx,dy)
  end

  if (player.x ~= x) or (player.y ~= y) then
    moves = moves + 1

    if (map.tiles[player.y-dy] ~= nil) and (map.tiles[player.y-dy][player.y-dx] ~= nil) then
      if map.tiles[player.y-dy][player.x-dx] == 'L' then
          map.tiles[player.y-dy][player.x-dx] = 'l'
      end
    end
    if (map.tiles[y+dy] ~= nil) and (map.tiles[y+dy][x+dx] ~= nil) then
      if map.tiles[y+dy][x+dx] == 'E' then
        map.tiles[y+dy][x+dx]  = 'e'
      end
    end

    createBeam(player.x, player.y, x, y)
    stepSounds[#stepSounds+1] = love.audio.newSource("Untitled.wav", "static")
    stepSounds[#stepSounds]:play()
    if #stepSounds > 10 then
      table.remove(stepSounds)
    end
  end
  player.x, player.y = x, y

  if (player.x == goalX) and (player.y == goalY) and not editEnable then
    loadLevel(currentLevel + 1)
  end

  if key == "f" then shaderEnabled  = not shaderEnabled end

  if (key == "e") then editEnable = not editEnable end

  if (key == "t") and editEnable then trailsEnabled = not trailsEnabled end


  if (key == "s") and editEnable then
    file = love.filesystem.newFile("levels/"..levelid..".map")
    file:open("w")
    file:write(playerStart.x.." "..playerStart.y.."\n")

    for i,line in ipairs(map.tiles) do
      local linestr = ""
      for _,c in ipairs(line) do
        if c == 'e' then c = 'E'
        elseif c == 'l' then c = 'L'
        elseif c == 'p' then c = 'P' end
        linestr = linestr..c
      end
      linestr = linestr.."\n"
      file:write(linestr)
    end
    file:close()
    --loadLevel(levelid)
  end


  if (key == "m") and editEnable then
    selectTile = selectTile + 1
  elseif (key == "n") and editEnable then
    selectTile = selectTile - 1
  end


  if (key == "l") then
    loadLevel(levelid)
  end
  if (key == "r") or (key == "escape" ) then
    loadLevel(currentLevel)
  end

end



function love.mousepressed( x, y, button )
  mx, my = screenToMap(x,y)
  --love.window.showMessageBox("","x: "..(x-love.graphics.getWidth()).."\ny: "..(y))
  local function clickDistance(tx,ty)

    return math.sqrt((x-tx)*(x-tx) + (y-ty)*(y-ty))
  end
  if love.system.getOS() ~= "Android" and (mx < #map.tiles[1]+1 and my < #map.tiles+1) then


    --[[
    if (button == "l") and (map.tiles[my] ~= nil) and (map.tiles[my][mx] ~= nil) then
      if map.tiles[my][mx] == '#' then map.tiles[my][mx] = ' '
      elseif map.tiles[my][mx] == ' ' then map.tiles[my][mx] = '#'
      end
    end
  ]]
    if (button == "r") and (map.tiles[my] ~= nil) and (map.tiles[my][mx] ~= nil) and editEnable then
      if goalY < #map.tiles and goalX < #map.tiles[1] then
        map.tiles[goalY][goalX] = ' '
      end
      goalX, goalY = mx, my
      map.tiles[goalY][goalX] = 'G'
    end

    if (button == "m") and not (love.keyboard.isDown("lctrl")) and (map.tiles[my] ~= nil) and (map.tiles[my][mx] ~= nil) and editEnable then
      player.x, player.y = mx, my
    end

    if (button == "m") and (love.keyboard.isDown("lctrl")) and (map.tiles[my] ~= nil) and (map.tiles[my][mx] ~= nil) and editEnable then
      playerStart.x, playerStart.y = mx, my
    end


  end
  if button == "l" then
    local w,h = love.graphics.getDimensions()
    if clickDistance(w - panelWidth + 40, h-60) < 16 and #map.tiles[1] > 1  and editEnable then
      for _,v in ipairs(map.tiles) do table.remove(v) end
    elseif clickDistance(w - panelWidth + 140, h-60) < 16  and editEnable then
      for _,v in ipairs(map.tiles) do table.insert(v,'#') end
    elseif clickDistance(w - panelWidth + 40, h-40) < 16 and #map.tiles > 1  and editEnable then
      table.remove(map.tiles)
    elseif clickDistance(w - panelWidth + 140, h-40) < 16  and editEnable then
      newline = {}
      for i = 1,#map.tiles[1] do
        table.insert(newline, '#')
      end
      table.insert(map.tiles, newline)
    elseif clickDistance(w - 88, h-105) < 16 and #map.tiles > 1  and editEnable then
      selectTile = selectTile - 1
    elseif clickDistance(w - 31, h-105) < 16 and #map.tiles > 1  and editEnable then
      selectTile = selectTile + 1
    elseif clickDistance(w - 175, 45) < 16 and #map.tiles > 1 then
      repeat
        currentLevel = currentLevel-1
      until love.filesystem.exists("levels/"..(currentLevel)..".map") or currentLevel < -999
      levelid = currentLevel
      if love.filesystem.exists("levels/"..(currentLevel)..".map") then
        loadLevel(currentLevel)
      end
    elseif clickDistance(w - 145, 45) < 16 and #map.tiles > 1 then
      repeat
        currentLevel = currentLevel+1
      until love.filesystem.exists("levels/"..(currentLevel)..".map") or currentLevel > 999
      levelid = currentLevel
      if love.filesystem.exists("levels/"..(currentLevel)..".map") then
        loadLevel(currentLevel)
      end
    end

    local w,h = love.graphics.getDimensions()
    w = w - panelWidth
    local mw, mh = #map.tiles[1], #map.tiles
    if mw/mh > w/h then
      tileSize = math.floor((w)/mw)
    else
      tileSize = math.floor(h/mh)
    end
  end

  if button == "wu" then
    levelid = levelid + 1
  elseif button == "wd" then
    levelid = levelid - 1
  end
end

function loadLevel(id)
  moves = 0
  for i,v in pairs(beams) do beams[i] = nil end
  file = love.filesystem.newFile("levels/"..id..".map")
  succes = file:open("r")
  if succes then
    local loadedMap = {}
    local i = 0
    for line in file:lines() do
      if i == 0 then
        local tFinal = {}
        line:gsub( "%d+", function(n) table.insert(tFinal, n) end)
        playerStart.x = tonumber(tFinal[1])
        playerStart.y = tonumber(tFinal[2])
        player.x = tonumber(tFinal[1])
        player.y = tonumber(tFinal[2])
      elseif i > 0 then
        local newline = {}
        for j = 1, #line do
          local c = line:sub(j,j)
          table.insert(newline, c)
          if c == 'G' then
            goalX, goalY = j,i
          end
        end
        table.insert(loadedMap, newline)
      end

      i = i+1
    end
    file:close()
    map.tiles = loadedMap
    local w,h = love.graphics.getDimensions()
    w = w - panelWidth
    local mw, mh = #map.tiles[1], #map.tiles
    if mw/mh > w/h then
      tileSize = math.floor((w)/mw)
    else
      tileSize = math.floor(h/mh)
    end
    currentLevel = id
  end
end

specTiles = {
  ['a'] = {type = "periodic", mod = 2, active = {true, false}},
  ['b'] = {type = "periodic", mod = 2, active = {false, true}},
  ['L'] = {type = "leave"},
  ['E'] = {type = "entry"},
  ['I'] = {type = "vertical"},
  ['-'] = {type = "horizontal"},
}

function love.update(dt)
  love.window.setTitle("currL:"..currentLevel.."[slot:"..levelid.."]  moves: "..moves)
  timer = timer + dt
  otime = timer + (60/140.5)*offset



  if love.mouse.isDown("l") and love.system.getOS() ~= "Android" and editEnable then
    mx, my = screenToMap(love.mouse.getPosition())

    if (map.tiles[my] ~= nil) and (map.tiles[my][mx] ~= nil) then
      map.tiles[my][mx] = drawTile[selectTile % #drawTile + 1]
    end
  end

  --[[if true then
    --somestring = "["..key.."] "..somestring

    local x,y = player.x, player.y
    if love.keyboard.isDown("up") then
      x,y = raycast(0,-1)
    elseif love.keyboard.isDown("down") then
      x,y = raycast(0,1)
    elseif love.keyboard.isDown("left") then
      x,y = raycast(-1,0)
    elseif love.keyboard.isDown("right") then
      x,y = raycast(1,0)
    end

    if (player.x ~= x) or (player.y ~= y) then
      createBeam(player.x, player.y, x, y)
      stepSounds[#stepSounds+1] = love.audio.newSource("Untitled.wav", "static")
      stepSounds[#stepSounds]:play()
      moves = moves + 1
    end
    player.x, player.y = x, y

    if (player.x == goalX) and (player.y == goalY) then
      loadLevel(currentLevel + 1)
    end

    canMove = false
  else
    canMove = true
  end]]



  shader:send("tim", timer)
  --shader:send("resolution", {love.graphics.getWidth(),love.graphics.getHeight()})

  player:update(dt)

  for i,v in pairs(beams) do
    v:update(dt)
  end

end

function isPassable(c)
  local result = true
  if c == '#' or c == 'p' then result = false end

  if specTiles[c] ~= nil then
    if specTiles[c].type == "periodic" then
      local modmoves = moves % specTiles[c].mod
      result = not specTiles[c].active[modmoves + 1]
    elseif specTiles[c].type == "horizontal" or specTiles[c].type == "vertical" then
      result = true
    else
      result = false
    end
  end

  return result
end


function love.resize( w, h )
  canvas = love.graphics.newCanvas(w-panelWidth,h)

  w = w - panelWidth
  local mw, mh = #map.tiles[1], #map.tiles
  if mw/mh > w/h then
    tileSize = math.floor((w)/mw)
  else
    tileSize = math.floor(h/mh)
  end
end

function love.draw()

  love.graphics.setCanvas(canvas)
  canvas:clear()
  love.graphics.setBlendMode("alpha")

  function drawBox(x, y, color)
    love.graphics.setColor(color)
    love.graphics.rectangle("fill", tileSize*(x-1), tileSize*(y-1), tileSize, tileSize)
  end
  local col = 255
  local bgColor =  {155,155,155}
  local blackColor =  {40,20,30}
  for y = 1,#map.tiles do
    for x = 1,#map.tiles[1] do
      if map.tiles[y][x] == '#' or map.tiles[y][x] == 'p' then
        drawBox(x, y, {40, 20, 30})
      elseif map.tiles[y][x] == ' ' then
        drawBox(x, y, bgColor)
      elseif map.tiles[y][x] == 'G' then
        drawBox(x, y, {col-50, col-50 ,col-50})
      elseif specTiles[map.tiles[y][x]] ~= nil then
        if specTiles[map.tiles[y][x]].type == "periodic" then
          if not isPassable(map.tiles[y][x]) then
            drawBox(x, y, {120, 40 ,20})
          else
            drawBox(x, y, {200, 160 ,170})
          end
          if editEnable then
            if map.tiles[y][x] == 'a' then
              love.graphics.setColor(255,0,0)
              love.graphics.rectangle("fill",tileSize*(x-1), tileSize*(y-1),6,6)
            elseif map.tiles[y][x] == 'b' then
              love.graphics.setColor(255,255,255)
              love.graphics.rectangle("fill",tileSize*(x-1), tileSize*(y-1),6,6)
            end
          end
        elseif specTiles[map.tiles[y][x]].type == "leave" then
          drawBox(x, y, {80, 200 ,80})
        elseif specTiles[map.tiles[y][x]].type == "entry" then
          drawBox(x, y, {80, 80 ,200})
        elseif specTiles[map.tiles[y][x]].type == "horizontal" then
          drawBox(x, y, {40, 20 ,30})
          love.graphics.setColor(bgColor)
          love.graphics.rectangle("fill", tileSize*(x-1), tileSize*(y-1) + tileSize*0.2, tileSize, tileSize*0.6)
        elseif specTiles[map.tiles[y][x]].type == "vertical" then
          drawBox(x, y, {40, 20 ,30})
          love.graphics.setColor(bgColor)
          love.graphics.rectangle("fill", tileSize*(x-1) + tileSize*0.2, tileSize*(y-1), tileSize*0.6, tileSize)
        end
      elseif map.tiles[y][x] == 'e' and editEnable then
        drawBox(x, y, bgColor)
        love.graphics.setColor({80, 80 ,200})
        love.graphics.setLineWidth(2*tileSize/32)
        love.graphics.rectangle("line", tileSize*(x-1)+1, tileSize*(y-1)+1, tileSize-2, tileSize-2)
      elseif map.tiles[y][x] == 'l' and editEnable then
        drawBox(x, y, bgColor)
        love.graphics.setColor({80, 200 ,80})
        love.graphics.setLineWidth(2*tileSize/32)
        love.graphics.rectangle("line", tileSize*(x-1)+1, tileSize*(y-1)+1, tileSize-2, tileSize-2)
      elseif map.tiles[y][x] == 'P' then
        drawBox(x, y, {40,20,30})
        love.graphics.setColor(bgColor)
        love.graphics.setLineWidth(4*tileSize/32)
        love.graphics.rectangle("line", tileSize*(x-1)+2, tileSize*(y-1)+2, tileSize-4, tileSize-4)
        love.graphics.line(tileSize*(x-1) + tileSize/2, tileSize*(y-1), tileSize*(x-1) + tileSize/2, tileSize*(y))
        love.graphics.line(tileSize*(x-1), tileSize*(y-1) + tileSize/2, tileSize*(x), tileSize*(y-1) + tileSize/2)
      else
        drawBox(x, y, bgColor)
      end
    end
  end

  love.graphics.setColor(140,100,220,120)
  love.graphics.setBlendMode("additive")

  for i,v in pairs(beams) do
    v:draw()
  end
  love.graphics.setBlendMode("alpha")

  color = {120,90,200}
  if editEnable then
    love.graphics.setColor(color)
    love.graphics.rectangle("fill", tileSize*(playerStart.x-1) + tileSize/4, tileSize*(playerStart.y-1) + tileSize/4, tileSize/2, tileSize/2)
  end

  drawBox(player.x, player.y, color)

  love.graphics.setColor(255,255,255)
  love.graphics.rectangle("line", tileSize*(player.x-1), tileSize*(player.y-1), tileSize, tileSize)
  love.graphics.setLineWidth(4*tileSize/32)
  love.graphics.setColor(40, 20, 30)
  love.graphics.rectangle("line", tileSize*(goalX-1) + tileSize/4, tileSize*(goalY-1) + tileSize/4, tileSize/2, tileSize/2)

  love.graphics.setCanvas()
  if shaderEnabled then
    love.graphics.setShader(shader)
  end

  love.graphics.setColor(255,255,255)
  love.graphics.draw(canvas)
  love.graphics.setShader()

  local w,h = love.graphics.getDimensions()
  local x,y = screenToMap(love.mouse.getPosition())
  if love.system.getOS() ~= "Android" and editEnable and (x < #map.tiles[1]+1 and y < #map.tiles+1) then
    love.graphics.setLineWidth(2)
    love.graphics.setColor(255,255,255,100)
    love.graphics.line(tileSize*(x-1) + tileSize/2, 0, tileSize*(x-1) + tileSize/2, h)
    love.graphics.line(0, tileSize*(y-1) + tileSize/2, w, tileSize*(y-1) + tileSize/2)
    love.graphics.setLineWidth(4*tileSize/32)
    love.graphics.rectangle("line", tileSize*(x-1), tileSize*(y-1), tileSize, tileSize)
  end



  local function drawSeparator(position)
    love.graphics.rectangle("fill", w-panelWidth, position, panelWidth, 4)
  end

  love.graphics.setColor(bgColor)
  love.graphics.rectangle("fill", w-panelWidth-4, 0, panelWidth+4, h)

  love.graphics.setFont(fontBig)
  love.graphics.setColor(200,200,200)
  love.graphics.printf(moves, w-panelWidth+1, 77, panelWidth+1, "center")
  love.graphics.setColor(blackColor)
  love.graphics.printf(moves, w-panelWidth, 76, panelWidth, "center")

  love.graphics.setFont(fontRegular)
  love.graphics.printf("moves:", w-panelWidth + 4, 64, panelWidth, "left")
  drawSeparator(60)
  love.graphics.rectangle("fill", w-panelWidth-2, 0, 4, h)
  love.graphics.printf("level ID: "..currentLevel.."\nselected slot: "..levelid, w-panelWidth + 4, 4, panelWidth, "left")

  drawSeparator(120)
  local infoText = ""
  if love.filesystem.exists("levels/"..levelid..".map") and editEnable then
    infoText = infoText.."Level ["..levelid.."] exists.\nSaving will overwrite!\n"
  end


  infoText = infoText..[[

                Controls:
                [arrow keys]: Movement
                [R]: Restart
                [Scroll wheel]: Change map slot
                [L]: Load map from selected slot
                [E]: Toggle MapEdit
                [F]: Blergh
                ]]
  if editEnable then
    infoText = infoText..[[

                  MapEdit:
                  [S]: Save current map to selected slot
                  [N/M]: Cycle through tiles
                  [left click]: Place tile
                  [Right click]: Move the goal
                  [Middle click]: Move the player square
                  [lctrl + middle click]: Move starting position
                  [T]: Toggle trail
                  ]]
  end

  love.graphics.printf(infoText, w-panelWidth + 4, 124, panelWidth-8, "left")

  local px, py = w - 165, 45
  love.graphics.polygon( "fill", px, py, px - 10, py + 5, px, py + 10)
  px = px + 20
  love.graphics.polygon( "fill", px, py, px + 10, py + 5, px, py + 10)

  if editEnable then
    love.graphics.setColor(bgColor)
    love.graphics.rectangle("fill",w - panelWidth+4, h-140, panelWidth-4, 140)
    love.graphics.setColor(blackColor)
    drawSeparator(h - 140)


    px, py = w - panelWidth + 40, h - 60
    py = py - 60
    love.graphics.print("selected tile: "..(selectTile % #drawTile + 1), px - 30, py-4)
    love.graphics.setFont(fontBig)
    love.graphics.print(drawTile[selectTile % #drawTile + 1],px + 90, py-10)
    love.graphics.setFont(fontRegular)
    px = px + 75
    py = py + 10
    love.graphics.polygon( "fill", px, py, px - 10, py + 5, px, py + 10)
    px = px + 50
    love.graphics.polygon( "fill", px, py, px + 10, py + 5, px, py + 10)

    local px, py = w - panelWidth + 40, h - 60
    py = py - 20
    love.graphics.print("["..x..", "..y.."]", px + 20, py-4)
    py = py + 20
    love.graphics.polygon( "fill", px, py, px - 10, py + 5, px, py + 10)
    px = px + 20
    love.graphics.print("width: "..#map.tiles[1], px, py-4)
    px = px + 80
    love.graphics.polygon( "fill", px, py, px + 10, py + 5, px, py + 10)

    px = w - panelWidth + 40
    py = py + 20
    love.graphics.polygon( "fill", px, py, px - 10, py + 5, px, py + 10)
    px = px + 20
    love.graphics.print("height: "..#map.tiles, px, py-4)
    px = px + 80
    love.graphics.polygon( "fill", px, py, px + 10, py + 5, px, py + 10)

  end

  love.graphics.setFont(fontDefault)
  --love.graphics.print(offset, 20,500)

  --love.graphics.printf(somestring, 20, 500,600)

end
